import { LightningElement, track } from 'lwc';
import getCardsList from 'c/graphicEducationalService';

const CARDS_LIST = [
    {
        id: 1,
        category: 'fractals',
        title: 'What are Fractals?',
        body: 'A fractal is a never-ending pattern. Fractals are infinitely complex patterns that are self-similar across different scales. They are created by repeating a simple process over and over in an ongoing feedback loop. Driven by recursion, fractals are images of dynamic systems – the pictures of Chaos. Geometrically, they exist in between our familiar dimensions. Fractal patterns are extremely familiar, since nature is full of fractals. For instance: trees, rivers, coastlines, mountains, clouds, seashells, hurricanes, etc. Abstract fractals – such as the Mandelbrot Set – can be generated by a computer calculating a simple equation over and over.',
    },
    {
        id: 2,
        category: 'fractals',
        title: 'Mandelbrot Set',
        body: 'The Mandelbrot set is an example of a fractal in mathematics. It is named after Benoît Mandelbrot, a Polish-French-American mathematician. The Mandelbrot set is important for chaos theory. The edging of the set shows a self-similarity, which is perfect, but because of the minute detail, it looks like it evens out. The Mandelbrot set can be explained with the equation f(z) = z*z + c. In that equation c and z are complex numbers and n is zero or a positive integer (natural number). Starting with z = 0, c is in the Mandelbrot set if the absolute value of z never becomes larger than a certain number (that number depends on), no matter how large n gets. Mandelbrot was one of the first to use computer graphics to create and display fractal geometric images, leading to his discovering the Mandelbrot set in 1979.',
    },
    {
        id: 3,
        category: 'colors',
        title: 'RGB Color Model',
        body: 'The RGB color model is an additive color model in which the red, green, and blue primary colors of light are added together in various ways to reproduce a broad array of colors. The name of the model comes from the initials of the three additive primary colors, red, green, and blue. The main purpose of the RGB color model is for the sensing, representation, and display of images in electronic systems, such as televisions and computers, though it has also been used in conventional photography. Before the electronic age, the RGB color model already had a solid theory behind it, based in human perception of colors. RGB is a device-dependent color model: different devices detect or reproduce a given RGB value differently, since the color elements (such as phosphors or dyes) and their response to the individual red, green, and blue levels vary from manufacturer to manufacturer, or even in the same device over time. Thus an RGB value does not define the same color across devices without some kind of color management.Typical RGB input devices are color TV and video cameras, image scanners, and digital cameras.',
    },
    {
        id: 4,
        category: 'colors',
        title: 'CMYK Color Model',
        body: 'The CMY color model is a subtractive color model in which cyan, magenta and yellow pigments or dyes are added together in various ways to reproduce a broad array of colors. The name of the model comes from the initials of the three subtractive primary colors: cyan, magenta, and yellow. The CMY color model itself does not define what is meant by cyan, magenta and yellow colorimetrically, and so the results of mixing them are not specified as absolute, but relative to the primary colors. When the exact chromaticities of the cyan, magenta, and yellow primaries are defined, the color model then becomes an absolute color space.',
    },
    {
        id: 5,
        category: 'transformation',
        title: 'Affine transformation',
        body: 'In Euclidean geometry, an affine transformation, or an affinity (from the Latin, affinis, "connected with"), is a geometric transformation that preserves lines and parallelism (but not necessarily distances and angles). More generally, an affine transformation is an automorphism of an affine space (Euclidean spaces are specific affine spaces), that is, a function which maps an affine space onto itself while preserving both the dimension of any affine subspaces (meaning that it sends points to points, lines to lines, planes to planes, and so on) and the ratios of the lengths of parallel line segments. Consequently, sets of parallel affine subspaces remain parallel after an affine transformation. An affine transformation does not necessarily preserve angles between lines or distances between points, though it does preserve ratios of distances between points lying on a straight line.',
    },
]


export default class GraphicEducational extends LightningElement {
    @track searchPattern = ''
    @track category = 'all'

    get cards() {
        let resultList = CARDS_LIST
        if(this.searchPattern.length > 0) {
            resultList = resultList.filter(
                card => card.title.toLowerCase().includes(this.searchPattern.toLowerCase())
            )
        }
        if(this.category !== 'all') {
            resultList = resultList.filter(
                card => card.category === this.category
            )
        }
        return resultList
    }

    get categoryOptions() {
        return [
            { label: 'All', value: 'all' },
            { label: 'Fractals', value: 'fractals' },
            { label: 'Colors', value: 'colors' },
            { label: 'Transformation', value: 'transformation' },
        ];
    }

    handleSearchChange(event) {
        this.searchPattern = event.target.value
    }

    handleCategoryChange(event) {
        this.category = event.target.value
    }
}